/*
********************************************************************************
* COPYRIGHT(c)    ϻ, 2020
* 
*        (as is).
*     .
********************************************************************************
*/


#include "Events.h"
#include "usb_audio_constants.h"



void Events_InitGPIOs(void)
{
  FREQ_EVENT_GPIO->MODER |= (1 << (2 * FREQ_EVENT_1_PIN)) | (1 << (2 * FREQ_EVENT_2_PIN)) |\
                            (1 << (2 * RES_EVENT_2_PIN));
  
  RES_EVENT_1_GPIO->MODER |= (1 << (2 * RES_EVENT_1_PIN)) | (1 << (2 * FREQ_EVENT_3_PIN));
  
  LED_GPIO->MODER |= 1 << (2 * LED_PIN);
}
//------------------------------------------------------------------------------
void Event_FreqChanged(uint32_t AudioFrequency)
{
  switch(AudioFrequency)
  {
    case USB_AUDIO_CONFIG_FREQ_44_1_K:
      FREQ_EVENT_3_GPIO->ODR &= ~FREQ_EVENT_3_PIN_MASK;
      FREQ_EVENT_GPIO->ODR &= ~FREQ_EVENT_MASK;
    break;
      
    case USB_AUDIO_CONFIG_FREQ_48_K:
    default:
      FREQ_EVENT_3_GPIO->ODR &= ~FREQ_EVENT_3_PIN_MASK;
      FREQ_EVENT_GPIO->ODR |= FREQ_EVENT_1_PIN_MASK;
      FREQ_EVENT_GPIO->ODR &= ~FREQ_EVENT_2_PIN_MASK;
    break;
    
    case USB_AUDIO_CONFIG_FREQ_88_2_K:
      FREQ_EVENT_3_GPIO->ODR |= FREQ_EVENT_3_PIN_MASK;
      FREQ_EVENT_GPIO->ODR &= ~FREQ_EVENT_1_PIN_MASK;
      FREQ_EVENT_GPIO->ODR |= FREQ_EVENT_2_PIN_MASK;
    break;
          
    case USB_AUDIO_CONFIG_FREQ_96_K:
      FREQ_EVENT_3_GPIO->ODR &= ~FREQ_EVENT_3_PIN_MASK;
      FREQ_EVENT_GPIO->ODR &= ~FREQ_EVENT_1_PIN_MASK;
      FREQ_EVENT_GPIO->ODR |= FREQ_EVENT_2_PIN_MASK;
    break;
    
    case USB_AUDIO_CONFIG_FREQ_176_4_K:
      FREQ_EVENT_3_GPIO->ODR |= FREQ_EVENT_3_PIN_MASK;
      FREQ_EVENT_GPIO->ODR |= FREQ_EVENT_MASK;
    break;
    
    case USB_AUDIO_CONFIG_FREQ_192_K:
      FREQ_EVENT_3_GPIO->ODR &= ~FREQ_EVENT_3_PIN_MASK;
      FREQ_EVENT_GPIO->ODR |= FREQ_EVENT_MASK;
    break;
  }
}
//------------------------------------------------------------------------------
void Event_ResChanged(uint8_t AudioResolution)
{
  if (AudioResolution == 16)
  {
    RES_EVENT_1_GPIO->ODR &= ~RES_EVENT_1_PIN_MASK;
    RES_EVENT_2_GPIO->ODR &= ~RES_EVENT_2_PIN_MASK;
  }
  else if (AudioResolution == 24)
  {
    RES_EVENT_1_GPIO->ODR |= RES_EVENT_1_PIN_MASK;
    RES_EVENT_2_GPIO->ODR &= ~RES_EVENT_2_PIN_MASK;
  }
  else if (AudioResolution == 32)
  {
    RES_EVENT_1_GPIO->ODR &= ~RES_EVENT_1_PIN_MASK;
    RES_EVENT_2_GPIO->ODR |= RES_EVENT_2_PIN_MASK;
  }
}
//------------------------------------------------------------------------------
void Event_MuteChanged(uint8_t MuteFlag)
{
  if (MuteFlag)
    LED_GPIO->ODR |= 1 << LED_PIN;
  else
    LED_GPIO->ODR &= ~(1 << LED_PIN);
}



